OpenTTD Source: NWidgetToolbarContainer Class Reference

OpenTTD Source 14.0-beta1

Public Member Functions | Protected Attributes
NWidgetToolbarContainer Class Referenceabstract

Full blown container to make it behave exactly as we want :) More...

Inheritance diagram for NWidgetToolbarContainer:

## Public Member Functions
bool | IsButton (WidgetType type) const
| Check whether the given widget type is a button for us. More...
void | SetupSmallestSize (Window *w) override
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
void | Draw (const Window *w) override
virtual const WidgetID * | GetButtonArrangement (uint &width, uint &arrangable_count, uint &button_count, uint &spacer_count) const =0
| Get the arrangement of the buttons for the toolbar. More...
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
void | AdjustPaddingForZoom () override
void | Add (std::unique_ptr< NWidgetBase > &&wid)
| Append widget wid to container. More...
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
void | Draw (const Window *w) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Protected Attributes
uint | spacers
| Number of spacer widgets in this toolbar.
Protected Attributes inherited from NWidgetContainer
std::vector< std::unique_ptr< NWidgetBase > > | children
| Child widgets in contaier.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Full blown container to make it behave exactly as we want :)

Definition at line 1332 of file toolbar_gui.cpp.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetToolbarContainer::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inlineoverridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1384 of file toolbar_gui.cpp.

## ◆ Draw()

void NWidgetToolbarContainer::Draw | ( | const Window * | w | ) |
| inlineoverridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1448 of file toolbar_gui.cpp.

References NWidgetContainer::Draw(), FILLRECT_CHECKER, GfxFillRect(), PC_DARK_RED, and PC_VERY_DARK_RED.

## ◆ GetButtonArrangement()

virtual const WidgetID* NWidgetToolbarContainer::GetButtonArrangement | ( | uint & | width,
|  | uint & | arrangable_count,
|  | uint & | button_count,
|  | uint & | spacer_count
| ) |  | const
| pure virtual

Get the arrangement of the buttons for the toolbar.

Parameters

  width | the new width of the toolbar.
  arrangable_count | output of the number of visible items.
  button_count | output of the number of visible buttons.
  spacer_count | output of the number of spacers.

Returns
  the button configuration.

Implemented in NWidgetScenarioToolbarContainer, and NWidgetMainToolbarContainer.

## ◆ IsButton()

bool NWidgetToolbarContainer::IsButton | ( | WidgetType | type | ) | const
| inline

Check whether the given widget type is a button for us.

Parameters

  type | the widget type to check.

Returns
  true if it is a button for us.

Definition at line 1346 of file toolbar_gui.cpp.

References NWidgetBase::type, WWT_IMGBTN, WWT_IMGBTN_2, and WWT_PUSHIMGBTN.

Referenced by SetupSmallestSize().

## ◆ SetupSmallestSize()

void NWidgetToolbarContainer::SetupSmallestSize | ( | Window * | w | ) |
| inlineoverridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Reimplemented in NWidgetScenarioToolbarContainer.

Definition at line 1351 of file toolbar_gui.cpp.

References _toolbar_width, NWidgetContainer::children, NWidgetBase::fill_x, NWidgetBase::fill_y, IsButton(), NWID_SPACER, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

Referenced by NWidgetScenarioToolbarContainer::SetupSmallestSize().

The documentation for this class was generated from the following file:

- src/toolbar_gui.cpp